Index: t3lib/stddb/tables.sql
===================================================================
--- t3lib/stddb/tables.sql	(Revision 2018)
+++ t3lib/stddb/tables.sql	(Arbeitskopie)
@@ -11,7 +11,7 @@
 #
 CREATE TABLE be_groups (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   title varchar(50) DEFAULT '' NOT NULL,
   non_exclude_fields text NOT NULL,
@@ -59,7 +59,7 @@
 #
 CREATE TABLE be_users (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   username varchar(50) DEFAULT '' NOT NULL,
   password varchar(40) DEFAULT '' NOT NULL,
@@ -218,7 +218,7 @@
 #
 CREATE TABLE sys_filemounts (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   title varchar(30) DEFAULT '' NOT NULL,
   path varchar(120) DEFAULT '' NOT NULL,
@@ -374,7 +374,7 @@
 #
 CREATE TABLE sys_language (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   hidden tinyint(4) unsigned DEFAULT '0' NOT NULL,
   title varchar(80) DEFAULT '' NOT NULL,
Index: typo3/sysext/cms/ext_tables.sql
===================================================================
--- typo3/sysext/cms/ext_tables.sql	(Revision 2018)
+++ typo3/sysext/cms/ext_tables.sql	(Arbeitskopie)
@@ -79,7 +79,7 @@
 #
 CREATE TABLE fe_groups (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   title varchar(50) DEFAULT '' NOT NULL,
   hidden tinyint(3) unsigned DEFAULT '0' NOT NULL,
@@ -125,7 +125,7 @@
 #
 CREATE TABLE fe_users (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   username varchar(50) DEFAULT '' NOT NULL,
   password varchar(40) DEFAULT '' NOT NULL,
@@ -208,7 +208,7 @@
 #
 CREATE TABLE static_template (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   crdate int(11) unsigned DEFAULT '0' NOT NULL,
   title tinytext NOT NULL,
@@ -227,7 +227,7 @@
 #
 CREATE TABLE sys_domain (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   hidden tinyint(4) unsigned DEFAULT '0' NOT NULL,
   domainName varchar(80) DEFAULT '' NOT NULL,
Index: typo3/sysext/cms/ext_tables_static+adt.sql
===================================================================
--- typo3/sysext/cms/ext_tables_static+adt.sql	(Revision 2018)
+++ typo3/sysext/cms/ext_tables_static+adt.sql	(Arbeitskopie)
@@ -10,7 +10,7 @@
 DROP TABLE IF EXISTS static_template;
 CREATE TABLE static_template (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   crdate int(11) unsigned DEFAULT '0' NOT NULL,
   title tinytext NOT NULL,
Index: typo3/sysext/sys_note/ext_tables.sql
===================================================================
--- typo3/sysext/sys_note/ext_tables.sql	(Revision 2018)
+++ typo3/sysext/sys_note/ext_tables.sql	(Arbeitskopie)
@@ -3,7 +3,7 @@
 #
 CREATE TABLE sys_note (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   deleted tinyint(3) unsigned DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   crdate int(11) unsigned DEFAULT '0' NOT NULL,
Index: typo3/sysext/rtehtmlarea/ext_tables.sql
===================================================================
--- typo3/sysext/rtehtmlarea/ext_tables.sql	(Revision 2018)
+++ typo3/sysext/rtehtmlarea/ext_tables.sql	(Arbeitskopie)
@@ -4,7 +4,7 @@
 
 CREATE TABLE tx_rtehtmlarea_acronym (
 	uid int(11) unsigned NOT NULL auto_increment,
-	pid int(11) unsigned DEFAULT '0' NOT NULL,
+	pid int(11) DEFAULT '0' NOT NULL,
 	deleted tinyint(4) unsigned DEFAULT '0' NOT NULL,
 	hidden tinyint(4) unsigned DEFAULT '0' NOT NULL,
 	starttime int(11) unsigned DEFAULT '0' NOT NULL,
Index: typo3/sysext/sys_action/ext_tables.sql
===================================================================
--- typo3/sysext/sys_action/ext_tables.sql	(Revision 2018)
+++ typo3/sysext/sys_action/ext_tables.sql	(Arbeitskopie)
@@ -3,7 +3,7 @@
 #
 CREATE TABLE sys_action (
   uid int(11) unsigned NOT NULL auto_increment,
-  pid int(11) unsigned DEFAULT '0' NOT NULL,
+  pid int(11) DEFAULT '0' NOT NULL,
   tstamp int(11) unsigned DEFAULT '0' NOT NULL,
   crdate int(11) unsigned DEFAULT '0' NOT NULL,
   cruser_id int(11) unsigned DEFAULT '0' NOT NULL,